package com.fp.persistence.pcustomer.balance;

import java.sql.Timestamp;
import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import com.fp.dto.hb.History;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que hace referencia a la Clave Primaria de TCUSTBALANCEFINANCIAL*/
@Embeddable
public class TcustBalanceFinancialKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId,History{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="DATETO", nullable=false,updatable=false)

/**
* Fecha hasta la cual esta vigente el registro
*/
private Timestamp dateto;

@Column(name="PERSONCODE", nullable=false,updatable=false)

/**
* Codigo de persona
*/
private Integer personcode;

@Column(name="ACCOUNTCODE", nullable=false,updatable=false)

/**
* Codigo de la cuenta de balance
*/
private String accountcode;

@Column(name="BALANCECATALOG", nullable=false,updatable=false)

/**
* Codigo de catalogo  01 Natural, 02 Juridico
*/
private String balancecatalog;

@Column(name="BALANCECATALOGCODE", nullable=false,updatable=false)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
private String balancecatalogcode;

@Column(name="BALANCEDATE", nullable=false,updatable=false)

/**
* Fecha de balance
*/
private Date balancedate;

/**Contructor por defecto*/
public TcustBalanceFinancialKey(){}
/**Contructor de TcustBalanceFinancialKey
@param pDateto Fecha hasta la cual esta vigente el registro
@param pPersoncode Codigo de persona
@param pAccountcode Codigo de la cuenta de balance
@param pBalancecatalog Codigo de catalogo  01 Natural, 02 Juridico
@param pBalancecatalogcode Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
@param pBalancedate Fecha de balance
*/
public TcustBalanceFinancialKey(Timestamp pDateto,Integer pPersoncode,String pAccountcode,String pBalancecatalog,String pBalancecatalogcode,Date pBalancedate){
 dateto=pDateto;
 personcode=pPersoncode;
 accountcode=pAccountcode;
 balancecatalog=pBalancecatalog;
 balancecatalogcode=pBalancecatalogcode;
 balancedate=pBalancedate;
}
/**Obtiene el valor de dateto
@return valor de dateto*/
public Timestamp getDateto(){
  return dateto;
}
/**Fija el valor de dateto
@param pDateto nuevo Valor de dateto*/
public void setDateto(Timestamp pDateto){
  dateto=pDateto;
}

/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Obtiene el valor de accountcode
@return valor de accountcode*/
public String getAccountcode(){
  return accountcode;
}
/**Fija el valor de accountcode
@param pAccountcode nuevo Valor de accountcode*/
public void setAccountcode(String pAccountcode){
  accountcode=pAccountcode;
}

/**Obtiene el valor de balancecatalog
@return valor de balancecatalog*/
public String getBalancecatalog(){
  return balancecatalog;
}
/**Fija el valor de balancecatalog
@param pBalancecatalog nuevo Valor de balancecatalog*/
public void setBalancecatalog(String pBalancecatalog){
  balancecatalog=pBalancecatalog;
}

/**Obtiene el valor de balancecatalogcode
@return valor de balancecatalogcode*/
public String getBalancecatalogcode(){
  return balancecatalogcode;
}
/**Fija el valor de balancecatalogcode
@param pBalancecatalogcode nuevo Valor de balancecatalogcode*/
public void setBalancecatalogcode(String pBalancecatalogcode){
  balancecatalogcode=pBalancecatalogcode;
}

/**Obtiene el valor de balancedate
@return valor de balancedate*/
public Date getBalancedate(){
  return balancedate;
}
/**Fija el valor de balancedate
@param pBalancedate nuevo Valor de balancedate*/
public void setBalancedate(Date pBalancedate){
  balancedate=pBalancedate;
}

/**Implementación de la comparación de TcustBalanceFinancialKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TcustBalanceFinancialKey))return false;
  TcustBalanceFinancialKey that = (TcustBalanceFinancialKey) o;
  if (this.getDateto() == null || that.getDateto() == null){
      return false;
  }
  if (! this.getDateto().equals(that.getDateto())){
    return false;
  }
  if (this.getPersoncode() == null || that.getPersoncode() == null){
      return false;
  }
  if (! this.getPersoncode().equals(that.getPersoncode())){
    return false;
  }
  if (this.getAccountcode() == null || that.getAccountcode() == null){
      return false;
  }
  if (! this.getAccountcode().equals(that.getAccountcode())){
    return false;
  }
  if (this.getBalancecatalog() == null || that.getBalancecatalog() == null){
      return false;
  }
  if (! this.getBalancecatalog().equals(that.getBalancecatalog())){
    return false;
  }
  if (this.getBalancecatalogcode() == null || that.getBalancecatalogcode() == null){
      return false;
  }
  if (! this.getBalancecatalogcode().equals(that.getBalancecatalogcode())){
    return false;
  }
  if (this.getBalancedate() == null || that.getBalancedate() == null){
      return false;
  }
  if (! this.getBalancedate().equals(that.getBalancedate())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TcustBalanceFinancialKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getDateto() == null ? 0 : this.getDateto().hashCode());
    result = result * 37 + (this.getPersoncode() == null ? 0 : this.getPersoncode().hashCode());
    result = result * 37 + (this.getAccountcode() == null ? 0 : this.getAccountcode().hashCode());
    result = result * 37 + (this.getBalancecatalog() == null ? 0 : this.getBalancecatalog().hashCode());
    result = result * 37 + (this.getBalancecatalogcode() == null ? 0 : this.getBalancecatalogcode().hashCode());
    result = result * 37 + (this.getBalancedate() == null ? 0 : this.getBalancedate().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
public Object getId() {
  return null;
}
}
